valentin/semifinals/urls.py
from django.urls import path
from django.contrib.auth.views import LoginView, LogoutView
from . import views

app_name = "semifinals"

urlpatterns = [
    path("login/", LoginView.as_view(), name="login"),
    path("logout/", LogoutView.as_view(next_page="/"), name="logout"),
    path("sessions/", views.SessionList.as_view(), name="session-list"),
    path(
        "session/<uuid:pk>/",
        views.SessionDetail.as_view(),
        name="session-details",
    ),
    path(
        "session/<uuid:pk>/subject",
        views.DownloadSessionSubjectView.as_view(),
        name="download-subject",
    ),
    path(
        "overseer/",
        views.SessionOverseerList.as_view(),
        name="session-overseer-list",
    ),
    path(
        "overseer/<uuid:session_id>/",
        views.SessionOverseer.as_view(),
        name="session-overseer",
    ),
    path(
        "contestant/", views.HomeContestant.as_view(), name="contestant-home"
    ),
    path("organizer/", views.HomeOrganizer.as_view(), name="organizer-home"),
    path("", views.HomeView.as_view(), name="home"),
]

valentin/valentin/urls.py
from django.contrib import admin
from django.urls import path, include

admin.site.site_header = "Administration Demi-Finales Prologin"

urlpatterns = [
    path("admin/", admin.site.urls),
    path("written-exams/", include("written_exams.urls")),
    path("itw/", include("interviews.urls")),
    path("", include("semifinals.urls")),
    path("social/", include("social_django.urls", namespace="social")),
]

valentin/written_exams/urls.py
from django.urls import path
from . import views

app_name = "written_exams"

contestant_urls = [
    path(
        "submission/<uuid:session_id>/",
        views.contestant.SubmissionUploadView.as_view(),
        name="submit-file",
    ),
    path(
        "form/<uuid:id>/",
        views.contestant.FormSubmissionView.as_view(),
        name="form-questions",
    ),
    path(
        "form/<uuid:id>/review/",
        views.contestant.FormReviewView.as_view(),
        name="form-review",
    ),
]

staff_urls = [
    path(
        "staff/form/",
        views.staff.FormInstanceListView.as_view(),
        name="form-list",
    ),
    path(
        "staff/form/<uuid:id>/test",
        views.staff.FormTestingView.as_view(),
        name="form-testing",
    ),
    path(
        "staff/form/<uuid:id>/answers",
        views.staff.FormAnswersListView.as_view(),
        name="form-answers-list",
    ),
    path(
        "staff/form/<uuid:id>/export",
        views.staff.FormGlobalExportView.as_view(),
        name="form-export",
    ),
    path(
        "staff/form-answer/<int:id>",
        views.staff.FormAnswersDetailView.as_view(),
        name="form-answers",
    ),
    path(
        "staff/submissions/<uuid:session_id>",
        views.staff.FileSubmissionsListView.as_view(),
        name="submissions-list",
    ),
    path(
        "staff/submission/dl/<int:submission_id>",
        views.staff.FileSubmissionDownloadView.as_view(),
        name="submission-download",
    ),
]

urlpatterns = contestant_urls + staff_urls

valentin/written_exams/models.py
from django.core.files.storage import FileSystemStorage
import os
from django.db import models
from django.contrib.auth import get_user_model
from pathlib import Path


class OverrideStorage(FileSystemStorage):
    OS_OPEN_FLAGS = os.O_CREAT | os.O_WRONLY | getattr(os, "O_BINARY", 0)

    def get_available_name(self, name, max_length=None):
        return name


def get_path(sub, filename):
    id = f"upstream_id_not_found_{sub.user.id}"
    if not (social := sub.user.social_auth.first()) is None:
        id = social.uid
    return Path("exams_submissions") / str(sub.session.id) / f"{str(id)}.pdf"


class Submission(models.Model):
    user = models.ForeignKey(
        to=get_user_model(),
        on_delete=models.CASCADE,
        limit_choices_to={"is_staff": False},
        verbose_name="Utilisateur",
    )
    session = models.ForeignKey(
        to="semifinals.Session", on_delete=models.CASCADE
    )
    last_updated = models.DateTimeField(null=True, blank=True)
    file = models.FileField(upload_to=get_path, storage=OverrideStorage())

    def __str__(self):
        return f"{self.user}@{self.session}"

    class Meta:
        unique_together = [("user", "session")]
        permissions = [
            ("can_export_submissions", "User can export submissions")
        ]

valentin/written_exams/forms.py
from django import forms
from django.core.exceptions import ValidationError


class SubmissionForm(forms.Form):
    file = forms.FileField()

    def clean_file(self):
        file = self.cleaned_data["file"]
        if file and file.content_type != "application/pdf":
            raise ValidationError("Le fichier envoyé doit être au format PDF.")

valentin/written_exams/views/contestant.py
from django.views.generic import View
from django.contrib.auth.mixins import LoginRequiredMixin
from django.core.exceptions import (
    ObjectDoesNotExist,
    SuspiciousOperation,
    PermissionDenied,
)
from django.http import HttpResponseBadRequest, Http404
from django.shortcuts import get_object_or_404, redirect
from django.urls import reverse
from django.utils import timezone
from ..models import Submission
from semifinals.models import Session, SessionStatuses
from ..forms import SubmissionForm

from se_forms import views as se_views


class SubmissionUploadView(LoginRequiredMixin, View):
    http_method_names = ("post",)

    def post(self, request, session_id, *args, **kwargs):
        if request.user.is_staff:
            raise SuspiciousOperation(
                "An organizer is trying to upload submission"
            )

        session = get_object_or_404(
            Session,
            id=session_id,
            status=SessionStatuses.OPEN,
            file_upload=True,
        )
        form = SubmissionForm(request.POST, request.FILES)

        if form.is_valid():
            submission = None
            try:
                submission = Submission.objects.get(
                    session=session, user=self.request.user
                )
            except ObjectDoesNotExist:
                submission = Submission(
                    session=session, user=self.request.user
                )

            submission.file = request.FILES["file"]
            submission.last_updated = timezone.now()
            submission.save()

            return redirect(
                reverse("semifinals:session-details", args=(session_id,))
            )
        return HttpResponseBadRequest("Provided File is not Valid")


class FormSubmissionView(se_views.SEEditableFormView):
    template_name = "written_exams/form-questions.html"

    def get_success_url(self):
        return reverse(
            "written_exams:form-questions", args=[self.exam_session.id]
        )

    def get_form_instance(self, id):
        try:
            self.exam_session = Session.get_user_sessions(
                self.request.user
            ).get(id=id, form__isnull=False, status=SessionStatuses.OPEN)
        except ObjectDoesNotExist:
            raise Http404

        return self.exam_session.form

    def form_valid(self, form):
        if not self.request.user.is_staff:
            return super().form_valid(form)
        raise PermissionDenied

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["exam_session"] = self.exam_session
        return context


class FormReviewView(FormSubmissionView):
    template_name = "written_exams/form-review.html"
    http_method_names = ("get",)

    def get_form_instance(self, id):
        try:
            self.exam_session = Session.get_user_sessions(
                self.request.user
            ).get(
                id=id,
                form__isnull=False,
                form_allow_review=True,
                status=SessionStatuses.SUBMISSIONS_CLOSED,
            )
        except ObjectDoesNotExist:
            raise Http404

        return self.exam_session.form

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        if not self.user_answer.last_updated:
            # user answers is not yet saved
            # <=> user did not submit the form during the exam
            raise Http404
        context["staff"] = self.request.user.is_staff
        return context

    def form_valid(self, form):
        return HttpResponseBadRequest("Form is read only")

valentin/written_exams/views/staff.py
from se_forms import views as se_views
from django.core.exceptions import ObjectDoesNotExist
from django.contrib.auth.mixins import PermissionRequiredMixin
from se_forms import models as se_models
from valentin.utils import EnsureStaffMixin
from django.http import JsonResponse, Http404
from django.urls import reverse
from django.views.generic import ListView, View
from django.db import transaction
from django.utils import timezone
from .. import models
from semifinals.models import Session
from django.conf import settings
from django.http import FileResponse, HttpResponse
from pathlib import Path


class FormTestingView(EnsureStaffMixin, se_views.BaseSEFormView):
    template_name = "written_exams/form-testing.html"

    def form_valid(self, form):
        return JsonResponse(
            {"is_valid": True, "cleaned_data": form.cleaned_data}
        )

    def form_invalid(self, form):
        dic = {
            "is_valid": False,
            "data": form.data,
            "errors": form.errors,
        }
        return JsonResponse(dic)

    def get_success_url(self):
        return reverse(
            "written_exams:form-testing", args=[self.form_instance.id]
        )


class FormInstanceListView(EnsureStaffMixin, ListView):
    model = se_models.FormInstance
    template_name = "written_exams/form-list.html"


class FormAnswersListView(EnsureStaffMixin, ListView):
    template_name = "written_exams/form-answers-list.html"

    def get_queryset(self):
        try:
            self.form_instance = se_models.FormInstance.objects.get(
                id=self.kwargs["id"]
            )
        except (ObjectDoesNotExist):
            raise Http404
        return self.form_instance.user_answers.all().order_by("-last_updated")

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        context["form_instance"] = self.form_instance
        return context


class FormAnswersDetailView(EnsureStaffMixin, se_views.SEFormView):
    template_name = "written_exams/form-review.html"
    http_method_names = ("get",)

    def get_extracted_form(self):
        try:
            self.user_answer = se_models.UserAnswers.objects.get(
                id=self.kwargs.pop("id")
            )
        except ObjectDoesNotExist:
            raise Http404
        self.form_instance = self.user_answer.form
        return self.form_instance.get_form()

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        context["staff"] = True
        if not (social := self.user_answer.user.social_auth.first()) is None:
            context["target_uid"] = social.uid
        return context


class FileSubmissionsListView(
    PermissionRequiredMixin, EnsureStaffMixin, ListView
):
    permission_required = ("written_exams.can_export_submissions",)
    template_name = "written_exams/submissions-list.html"

    def get_queryset(self):
        try:
            self.session = Session.objects.get(id=self.kwargs["session_id"])
            return models.Submission.objects.filter(
                session_id=self.session.id
            ).order_by("-last_updated")
        except ObjectDoesNotExist:
            raise Http404

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        context["session"] = self.session
        return context


class FileSubmissionDownloadView(
    PermissionRequiredMixin, EnsureStaffMixin, View
):
    permission_required = ("written_exams.can_export_submissions",)
    http_method_names = ("get",)

    def get_x_accel(self, submission):
        res = HttpResponse(status=200)
        res["X-Accel-Redirect"] = Path(settings.APP_X_ACCEL_PATH) / Path(
            submission.file.path
        ).relative_to(settings.MEDIA_ROOT)
        res["Content-Type"] = ""
        return res

    def get(self, request, submission_id, **kwargs):
        submission = None
        try:
            submission = models.Submission.objects.get(id=submission_id)
        except ObjectDoesNotExist:
            raise Http404

        if settings.APP_USE_X_ACCEL_REDIRECT:
            return self.get_x_accel(submission)

        return FileResponse(open(submission.file.path, "rb"))


class FormGlobalExportView(EnsureStaffMixin, View):
    http_method_names = ("get",)

    def get(self, request, id, *args, **kwargs):
        with transaction.atomic():
            try:
                form_instance = se_models.FormInstance.objects.get(id=id)
            except ObjectDoesNotExist:
                raise Http404

            dic = {}
            dic["id"] = form_instance.id
            dic["display_name"] = form_instance.display_name
            dic["answers"] = []

            for user_answer in form_instance.user_answers.filter(
                user__is_staff=False
            ):
                res = {
                    "user": {"has_social_auth": False, "prologin_uid": None}
                }
                res["user"]["first_name"] = user_answer.user.first_name
                res["user"]["last_name"] = user_answer.user.last_name
                res["user"]["email"] = user_answer.user.email

                if (
                    not (social := user_answer.user.social_auth.first())
                    is None
                ):
                    res["user"]["has_social_auth"] = True
                    res["user"]["prologin_uid"] = social.uid

                res["answers"] = user_answer.answers
                res["last_updated"] = user_answer.last_updated

                dic["answers"].append(res)

            dic["export_date"] = timezone.now()
            date_filename = dic["export_date"].strftime("%Y-%m-%d-%Hh-%Mm-%Ss")

            response = JsonResponse(dic)
            response[
                "Content-Disposition"
            ] = f"attachment; filename={form_instance.id}_{date_filename}.json;"  # noqa
            return response

valentin/written_exams/templates/written_exams/form-answers-list.html
{% extends 'semifinals/base.html' %}
{% load static %}

{% block base_extra_head %}
<title>Liste des réponses au formulaire {{ form_instance }}</title>
<link rel="stylesheet" href="{% static 'semifinals/css/form-list.css' %}">
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'written_exams:form-list' %}">&lt;&nbsp; Retour à la liste des instances</a></small>
    <h1 class="trb">Réponses à {{ form_instance }}</h1>

    {% if object_list %}
        <ul class="answers-list">
            {% for o in object_list %}
            {{ p }}
            <li><a href="{% url 'written_exams:form-answers' o.id %}"><span>{{ o.user_full_name }}</span> <span>{{ o.last_updated | date:'d F Y à H:i:s' }}</span></a></li>
            {% endfor %}
        </ul>
    {% else %}
        <p>Il n'y a pas encore de réponses à cette instance de formulaire.</p>
    {% endif %}
</div>
{% endblock %}

valentin/written_exams/templates/written_exams/form-list.html
{% extends 'semifinals/base.html' %}

{% block base_extra_head %}
<title>Liste des instances de formulaires</title>
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'semifinals:home' %}">&lt;&nbsp; Retour à l'espace organisateur</a></small>
    <h1 class="trb">Liste des instances de formulaires</h1>

    {% if object_list %}
        <section class="window-list">
        {% for instance in object_list %}
            <article class="window">
                <div class="window-title-bar">
                    <span class="window-title"><img src="https://prologin.org/static/img/logo_cube.png" alt="icon prologin" width="22px" height="22px"><span>&nbsp;Instance de formulaire : {{ instance.id }}</span></span>
                    <span class="window-title-icons">
                        <button class="windows-button">❐</button>
                        <button class="windows-button">—</button>
                        <button class="windows-button">X</button>
                    </span>
                </div>
                <div class="window-body">
                    <p>Nom du formulaire : <b>{{ instance.display_name }}</b></p>
                    <br><hr>
                    <p class="align-right"><a href="{% url 'written_exams:form-export' instance.id %}" class="windows-button">Exporter les réponses</a></p>
                    <p class="align-right"><a href="{% url 'written_exams:form-answers-list' instance.id %}" class="windows-button">Voir les réponses</a></p>
                    <p class="align-right"><a href="{% url 'written_exams:form-testing' instance.id %}" class="windows-button">Tester ce formulaire</a></p>
                </div>
            </article>
        {% endfor %}
        </section>
    {% else %}
        <center>
            <p>Il n'existe pas encore d'instance de formulaire</p>
            <p>Vous pouvez créer une instance de formulaire dans l'<a href="{% url 'admin:se_forms_forminstance_add' %}">Admin Django</a></p>
        </center>
    {% endif %}
</div>
{% endblock %}

valentin/written_exams/templates/written_exams/form-questions.html
{% extends 'semifinals/base.html' %}
{% load static %}


{% block base_extra_head %}
<title>Questionnaire {{ exam_session }}</title>
<meta name="notif-changed-element" value="not-saved-alert">
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'semifinals:session-details' exam_session.id %}">&lt;&nbsp; Retour à l'épreuve</a></small>
    <h1 class="trb">{{ exam_session }}</h1>

    {% if extracted_form.introduction %}
        <p>{{ extracted_form.introduction | linebreaks | urlize }}</p>
    {% endif %}
    {% if user_answer.last_updated %}
        <div class="alert alert-secondary"><i class="las la-user-clock"></i>&nbsp; votre dernier rendu de ce formulaire date du <b>{{ user_answer.last_updated | date:'d F Y à H:i:s' }}</b></div>
    {% else %}
        <div class="alert alert-secondary"><i class="las la-user-clock"></i>&nbsp; <b>vous n'avez pas encore répondu à ce questionnaire</b></div>
    {% endif %}

    <h2>Vos réponses</h2>
    {% if request.user.is_staff %}
        <div class="alert alert-danger">Les membres du staff ne peuvent pas sauvegarder leurs réponses.</div>
    {% endif %}
    <div style="display: none;" class="alert alert-warning" id="not-saved-alert"><i class="las la-exclamation-triangle"></i>&nbsp; Attention : vos réponses au questionnaire ne sont pas sauvegardées. Pensez bien à cliquer sur sauvegarder même si vous n'avez pas encore tout complété.</div>
    <form action="" method="POST">
        {% csrf_token %}
        {% include 'written_exams/form-stub.html' with form=form %}
        <br>
        <button class="btn btn-block btn-success">SAUVEGARDER</button>
    </form>
</div>
{% endblock %}

{% block extra_body %}
<script src="{% static 'se_forms/js/fieldchangewatcher.js' %}" type="application/javascript"></script>
{% endblock %}

valentin/written_exams/templates/written_exams/form-review.html
{% extends 'semifinals/base.html' %}
{% load static %}


{% block base_extra_head %}
{% if staff %}
<title>Réponses de {{ user_answer.user.first_name }} {{ user_answer.user.last_name }} à {{ form_instance }}</title>
{% else %}
<title>Questionnaire {{ exam_session }}</title>
{% endif %}
{% endblock %}

{% block content %}
<div class="container">
    {% if not staff %}
    <small class="return-button"><a href="{% url 'semifinals:session-details' exam_session.id %}">&lt;&nbsp; Retour à l'épreuve</a></small>
    <h1 class="trb">{{ exam_session }} (Relecture)</h1>
    {% else %}
    <small class="return-button"><a href="{% url 'written_exams:form-answers-list' form_instance.id %}">&lt;&nbsp; Retour à l'espace réponses</a></small>
    <h1 class="trb">{{ form_instance }}</h1>
    {% endif %}

    {% if user_answer.last_updated %}
        <div class="alert alert-secondary"><i class="las la-user-clock"></i>&nbsp; Dernier rendu du formulaire <b>{{ user_answer.last_updated | date:'d F Y à H:i:s' }}</b></div>
    {% else %}
        <div class="alert alert-secondary"><i class="las la-user-clock"></i>&nbsp; <b>Vous n'avez pas rendu ce formulaire</b></div>
    {% endif %}


    {% if staff %}
    <h2>Réponses de {{ user_answer.user.first_name }} {{ user_answer.user.last_name }}</h2>
    {% if target_uid %}
        <small>UID Site Prologin : {{ target_uid }}</small>
    {% endif %}
    {% else %}
    <h2>Vos réponses</h2>
    {% endif %}
    <div class="alert alert-primary">Ce questionnaire est en lecture seule.</div>
    <form action="#" method="GET">
        {% include 'written_exams/form-stub.html' with form=form %}
    </form>
</div>
{% endblock %}

{% block extra_body %}
<script>
    document.querySelectorAll('input, textarea, select').forEach(e => { e.setAttribute("disabled", "true"); });
</script>
{% endblock %}

valentin/written_exams/templates/written_exams/form-stub.html
{% if form.errors %}
<div class="form-errors alert alert-danger">
    <i class="las la-exclamation-circle"></i>&nbsp;Le formulaire rendu contient des erreurs. Corrigez-les afin de pouvoir sauvegarder vos réponses.<br>
    {% if form.non_field_errors %}
        <ul>
        {% for error in form.non_field_errors %}
            <p>{{ error }}</p>
        {% endfor %}
        </ul>
    {% endif %}
</div>
{% endif %}

{% for field in form.visible_fields %}
<div class="form-element {% if field.errors %}form-element-error{% endif %}">
    {% if field.errors %}
        {% for error in field.errors %}
        <p class="color-danger"><i class="las la-exclamation-circle"></i>&nbsp;<b class="color-danger">{{ error }}</b></p>
        {% endfor %}
    {% endif %}
    <p class="question">{{ field.label }}</p>
    {{ field }}
    <span class="help-text">{{ field.help_text | linebreaks }}</span>
</div>
{% endfor %}

valentin/written_exams/templates/written_exams/form-testing.html
{% extends 'semifinals/base.html' %}
{% load static %}


{% block base_extra_head %}
<title>Test du formulaire {{ form_instance }}</title>
<meta name="notif-changed-element" value="not-saved-alert">
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'written_exams:form-list' %}">&lt;&nbsp; Retour à la liste des instances</a></small>
    <h1 class="trb">Test du formulaire : {{ form_instance }}</h1>
    <div class="alert alert-warning"><i class="las la-flask"></i>&nbsp;Ceci est une version de test du formulaire, vos réponses ne sont pas enregistrées.</div>

    {% if extracted_form.introduction %}
        <p>{{ extracted_form.introduction | linebreaks | urlize }}</p>
    {% endif %}

    <h2>Vos réponses</h2>
    <div style="display: none;" class="alert alert-warning" id="not-saved-alert"><i class="las la-exclamation-triangle"></i>&nbsp; Attention : vos réponses au questionnaire ne sont pas sauvegardées. Pensez bien à cliquer sur sauvegarder même si vous n'avez pas encore tout complété.</div>
    <form action="" method="POST">
        {% csrf_token %}
        {% include 'written_exams/form-stub.html' with form=form %}
        <br>
        <button class="btn btn-block btn-success">SAUVEGARDER</button>
    </form>
</div>
{% endblock %}

{% block extra_body %}
<script src="{% static 'se_forms/js/fieldchangewatcher.js' %}" type="application/javascript"></script>
{% endblock %}

valentin/written_exams/templates/written_exams/submission.html
<h2>Rendu de fichiers</h2>

{% if object.status == 2 %}
    <p>Utilisez le formulaire ci-dessous pour rendre votre copie.
        Vous pouvez rendre votre copie autant de fois que nécéssaire, nous garderons la dernière version envoyée.
    </p>

    <p>Conditions sur le fichier rendu</p>
    <ul>
        <li>Format PDF</li>
        <li>Taille maximale : {{ settings.APP_MAX_UPLOAD_SIZE }}.</li>
    </ul>

    <p><em>Remarque: si votre fichier PDF est trop lourd, vous pouvez le compresser grâce à des outils en ligne.</em></p>

    <br>

    <fieldset>
        <legend>Téléversement</legend>
        {% if user.is_staff %}
            <p>Les rendus de fichiers ne sont pas autorisés pour les membres du staff.</p>
        {% else %}
        {% if submission %}
            <p class="last-handout">Votre dernier rendu date du <b>{{ submission.last_updated | date:'d F Y H:i:s' }}</b></p>
        {% else %}
            <p class="last-handout">Vous n'avez pas encore effectué de rendu.</p>
        {% endif %}
        <form method="POST" enctype="multipart/form-data" action="{% url 'written_exams:submit-file' object.id %}">
            <p><input type="file" accept="application/pdf" name="file" required multiple="no"></p>
            <button class="btn btn-block btn-success"><i class="las la-cloud-upload-alt"></i> ENVOYER</button>
            {% csrf_token %}
        </form>
        {% endif %}
    </fieldset>
{% else %}
    <h4>L'épreuve est fermée, vous ne pouvez plus rendre de fichiers.</h4>
    {% if submission %}
        <div class="alert alert-success">Info: votre dernier rendu date du <b>{{ submission.last_updated | date:'d F Y H:i:s' }}</b></div>
    {% else %}
        <div class="alert alert-warning">Info: vous n'avez pas rendu de copie pour cette session.</div>
    {% endif %}
{% endif %}

valentin/written_exams/templates/written_exams/submissions-list.html
{% extends 'semifinals/base.html' %}
{% load static %}

{% block base_extra_head %}
<title>Fichiers {{ session }}</title>
<link rel="stylesheet" href="{% static 'semifinals/css/form-list.css' %}">
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'semifinals:session-overseer' session.id %}">&lt;&nbsp; Retour à la liste des instances</a></small>
    <h1 class="trb">Réponses à {{ session }}</h1>

    {% if object_list %}
        <ul class="answers-list">
            {% for o in object_list %}
            {{ p }}
            <li><a href="{% url 'written_exams:submission-download' o.id %}" target="_blank"><span>{{ o.user.first_name }} {{ o.user.last_name }}</span> <span>{{ o.last_updated | date:'d F Y à H:i:s' }}</span></a></li>
            {% endfor %}
        </ul>
    {% else %}
        <p>Il n'y a pas encore de réponses à cette instance de formulaire.</p>
    {% endif %}
</div>
{% endblock %}